// ==UserScript==
// @name           niconico re-form user JavaScript
// @namespace      http://www33.atwiki.jp/imas/
// @description    re-form nicovideo page and add "flv download w/ nicovine" bottun.
// @include        http://www.nicovideo.jp/watch/*
// @version 1.0.0
// ==/UserScript==

//----[各種設定　始まり]-------------------------------------------------------------

    //最大化時の挙動の初期値を指定する。
    //0:動画のみ
    //1:SeekBar
    //2:Comment
var IMAS_selResizeMethod=1;

    //メインタブの時に動画の再生数、コメント数、マイリスト数の取得間隔を決定する。単位は[ms]
    //つまり5000を指定すると5000[ms]=5秒毎に取得します
var IMAS_ratio_counter=5000;

    //コメ読みタブの時にコメントを読み込む速度を決定する。計算式は複雑なので割愛。
    //1000を指定すると1秒間に50コメを拾ってきます。
    //重いと思ったら値を大きく、もっと早くしたいと思ったら値を小さくして下さい。
var IMAS_ratio_readComment=500;

    //シンプルダウンロードボタン
    //'true'にするとシンプルなダウンロードボタンのみになります。
    //'false'にすると機能がタブ化されてすっきりします。
var IMAS_simple=false;

    //テスト＆デバッグ用
    //普通は0でします。
var IMAS_debug=0;
var IMAS_debug2=0;

//----[各種設定　終わり]-------------------------------------------------------------
/*
Prefix一覧
IMAS_　　変数・オブジェクト定義名
Imas_　　関数
imas_　　属性・属性名
*/
var IMAS_handle_timer;
var IMAS_handle_comment;
var IMAS_length_provider_comment_height;
var IMAS_message_no;
var IMAS_player_no;
var IMAS_isState;
var IMAS_isTimer;
var IMAS_flvp;
var IMAS_tab_ctrl;


//テスト
function Imas_test(){
	var txt = document.getElementById("imas_test_text");
	var str="";
	txt.innerHTML=str;
	return;
}


//***********************************************
//　　　ブラウザ間互換用オブジェクト
//***********************************************
var uWindow = (typeof(unsafeWindow)!= 'undefined')? unsafeWindow : window;
if(typeof(Video)== 'undefined'){
	var Video=uWindow.Video;
}

//***********************************************
//　　　ブラウザ間互換用関数
//***********************************************
function addListener(elem, eventType, func, cap){
    if(elem.addEventListener){
        elem.addEventListener(eventType, func, cap);
    }else if(elem.attachEvent){
//        elem.attachEvent('on' + eventType, func);
        elem['on' + eventType]= func;
    }
}

function getWindowWidth(){
  if(window.innerWidth) return window.innerWidth; // Mozilla, Opera, NN4
  if(document.documentElement && document.documentElement.clientWidth){ // 以下 IE
   return document.documentElement.clientWidth;
  }
  else if(document.body && document.body.clientWidth){
   return document.body.clientWidth;
  }
  return 0;
}

function getWindowHeight(){
  if(window.innerHeight) return window.innerHeight; // Mozilla, Opera, NN4
  if(document.documentElement && document.documentElement.clientHeight){ // 以下 IE
   return document.documentElement.clientHeight;
  }
  else if(document.body && document.body.clientHeight){
   return document.body.clientHeight;
  }
  return 0;
}

function Imas_addCSSRule( selector, property) {
  var sheet = document.styleSheets[ 0 ];

  if( sheet.addRule ) { //IE
      var ruleindex = sheet.rules.length;
      sheet.addRule( selector, "{" + property + "}" );
      return ruleindex;
  }
  else if( GM_addStyle ) { //GM
		GM_addStyle( selector+ "{" + property + "}")
  }
  else if( sheet.insertRule ) { //Mozilla
      var ruleindex = sheet.cssRules.length;
      return sheet.insertRule( selector + "{" + property + "}" );
  }
  return;
}

//***********************************************
//　　　テーブルレイアウト用ツール
//***********************************************
function IMAS_tableObj(row,col){
	var ary=new Array(row);
	for(var i=0;i<ary.length;i++){
		ary[i]=new Array(col);
	}
	this.ary=ary;
	this.row=row;
	this.col=col;
	this.table=document.createElement("table");
	this.table.cellSpacing=0;
	this.table.cellPadding=0;
	this.table.border=0;
	return this;
}
IMAS_tableObj.prototype.createTable = function(){
	var ary=this.ary;
	for(var row=0 ; row<this.row ; row++){
		var rowObj=this.table.insertRow(row);
		for(var col=0 ; col<this.col ; col++){
			if(typeof(ary[row][col])=='undefined'){
				rowObj.appendChild(document.createElement("td"));
			}else if(typeof(ary[row][col])!='number'){
				rowObj.appendChild(ary[row][col]);
			}
		}
	}
	return this.table;
}
IMAS_tableObj.prototype.getCell = function(posRow,posCol){
	var cell=this.ary[posRow][posRow];
	if(typeof(cell)=='number'){
		cell=this.ary[cell/this.col][cell%this.col];
	}
	return cell;
}
IMAS_tableObj.prototype.createCell = function(posRow,posCol,lenRow,lenCol){
	if(typeof(lenRow)=='undefined')lenRow=1;
	if(typeof(lenCol)=='undefined')lenCol=1;
	
	var ary=this.ary;
	var pos=this.col*posRow+posCol;
	for(var row=0 ; row<lenRow ; row++){
		for(var col=0 ; col<lenCol ; col++){
			if(typeof(ary[posRow+row][posCol+col])=='undefined'){
				ary[posRow+row][posCol+col]=pos;
			}else{
				alert("error");
			}
		}
	}
	var cell=document.createElement("td");
	cell.rowSpan=lenRow;
	cell.colSpan=lenCol;
	ary[posRow][posCol]=cell;
	return cell;
}

//***********************************************
//　　　タブ作成ツール
//***********************************************
function IMAS_tabObj(argsObj,id){
  this.classTab       = "imas_cnt";
  this.classTabHide   = "imas_cnthide";
  this.classNav       = "imas_tab";
  this.classNavActive = "imas_active";
  this.classNavExt    = "imas_ext";
  this.REclassTabHide = new RegExp('\\b' + this.classTabHide + '\\b', 'gi');

	Imas_addCSSRule(".imas_cnthide"           ,"display:none;");
	Imas_addCSSRule("ul.imas_tab"             ,"margin:0; padding: 1px 0; border-bottom: 1px solid #778; font: bold 12px 'ヒラギノ角ゴ Pro W3','Hiragino Kaku Gothic Pro',sans-serif;");
	Imas_addCSSRule("ul.imas_tab li"          ,"list-style: none; margin: 0; display: inline;");
	Imas_addCSSRule("ul.imas_tab li a"        ,"padding: 1px 0.5em; margin-left: 3px; border: 1px solid #778; border-bottom: none; background: #DDE; text-decoration: none;");
	Imas_addCSSRule("ul.imas_tab li a:link"   ,"color: #448;");
	Imas_addCSSRule("ul.imas_tab li a:visited","color: #667;");
	Imas_addCSSRule("ul.imas_tab li a:hover"  ," color: #000; background: #AAE; border-color: #227;");
	Imas_addCSSRule("ul.imas_tab li.imas_active a"      ,"background-color: #fff; border-bottom: 1px solid #fff;");
	Imas_addCSSRule("ul.imas_tab li.imas_active a:hover","color: #000; background: white; border-bottom: 1px solid white;");
	Imas_addCSSRule("ul.imas_tab li.imas_ext a"         ,"padding: 0px 0.5em; margin-left: 4px; border: none; background: #EEE; text-decoration: none;");
	Imas_addCSSRule("ul.imas_tab li.imas_ext a:hover"   ,"color: #000; background: white; border-bottom: 1px solid white;");

  this.tabs = new Array();
  if (argsObj) {
    this.init(argsObj,id);
  }
  IMAS_tab_ctrl[id]=this;
}

IMAS_tabObj.prototype.init = function(tab1Obj,id){
  var
  childNodes,
  i, i2,tmp,tabMain,
  disaObj;

	tabMain=this;
	tabMain.tabs.length=0;

  childNodes = tab1Obj.childNodes;
  for(i=0; i < childNodes.length; i++) {
    if(childNodes[i].tagName && childNodes[i].tagName=="DIV") {
		tmp=new Object();
		tmp.div = childNodes[i];
        this.tabs[this.tabs.length] = tmp;
    }
  }

	disaObj = document.createElement("ul");
	disaObj.className=this.classNav;
	i2=0;
	var ary=[
		["メイン"  ,""       ,"javascript:Imas_setTimer();"],
		["ニコ市場",""       ,"javascript:Imas_ichiba();"],
		["コメ書き",""       ,"javascript:void(null);"],
		["コメ読み",""       ,"javascript:Imas_setTimer();"],
		["その他"  ,""       ,"javascript:void(null);"],
		["Wiki"   ,"imas_ext","javascript:Imas_copy2Wiki();"],
		["Top"    ,"imas_ext","http://www.nicovideo.jp/"],
		["Imas"   ,"imas_ext","http://www.nicovideo.jp/tag/%E3%82%A2%E3%82%A4%E3%83%89%E3%83%AB%E3%83%9E%E3%82%B9%E3%82%BF%E3%83%BC?sort=f"],
		["Ranking","imas_ext","http://www.nicovideo.jp/ranking/mylist/daily/all"],
		["MyPage" ,"imas_ext","http://www.nicovideo.jp/my"],
		["Similar","imas_ext",location.href.replace( "/watch/" , "/openlist/" )],
		["Random" ,"imas_ext","http://www.nicovideo.jp/random"],
		["Tag"    ,"imas_ext","http://www.nicovideo.jp/tag"],
		["History","imas_ext","http://www.nicovideo.jp/history"],
		["PageTop","imas_ext","JavaScript:ANCHOR('PAGETOP');"],
		["Logout" ,"imas_ext","https://secure.nicovideo.jp/secure/logout"]
	];
	for(var k=0;k<ary.length;k++){
		var listObj = document.createElement("li");
		var ancrObj = document.createElement("a");
		ancrObj.innerHTML = ary[k][0];
		ancrObj.href = ary[k][2];
		listObj.className=ary[k][1];
		listObj.appendChild(ancrObj);
		disaObj.appendChild(listObj);
		if(ary[k][1]!="imas_ext"){
			tabMain.tabs[i2].li = listObj;
			ancrObj.setAttribute("tabbarIndex",i2);
			ancrObj.setAttribute("tabbarID",id);
			addListener(ancrObj,"click",this.clickTab,false);
			i2++;
		}
		
	}
	tab1Obj.insertBefore(disaObj,tab1Obj.firstChild);

  this.showTab(0);

  return this;
}

IMAS_tabObj.prototype.clickTab = function(){
  var tabbar=IMAS_tab_ctrl[this.getAttribute("tabbarID")];
  if(!tabbar){return false;}
  this.blur();
  tabbar.showTab(this.getAttribute("tabbarIndex"));
  return true;
}

IMAS_tabObj.prototype.showTab = function(tabberIndex){
  var div,i;

  if (!this.tabs[tabberIndex]) { return false; }

  for (i = 0; i < this.tabs.length; i++) {
	  div = this.tabs[i].div;
	  if (!div.className.match(this.REclassTabHide)) {
	    div.className += ' ' + this.classTabHide;
	  }
	  this.tabs[i].li.className = '';
  }

	IMAS_isState=tabberIndex;
  div = this.tabs[tabberIndex].div;
  div.className = div.className.replace(this.REclassTabHide, '');
  this.tabs[tabberIndex].li.className = this.classNavActive;

  return this;
}

//***********************************************
//　　　各種操作関数
//***********************************************
function Imas_downloadWithIrvine( dTitle , dUrl ){
	var Irvine;
	var IrvineItem;
	try{
	  Irvine     = new ActiveXObject('Irvine.API');
	  IrvineItem = new ActiveXObject('Irvine.Item');
	}catch (err){
	  alert('irvineをインストールしてから実行して下さい');
	  return;
	}

	var Folder = Irvine.Default;
	var Cur=Folder;
	for(i=0;i<Folder.FolderCount;i++){
	  if(Folder.Folders(i).Name=="niconico"){
	     Cur=Folder.Folders(i);break;
	  }
	}
	var dCookie=/user_session=user_session_\d+_\d+/.exec(document.cookie) + ';';
	IrvineItem.Filename = dTitle;
	IrvineItem.Url = dUrl;
	IrvineItem.Comment = dUrl;
	IrvineItem.Cookie = dCookie;
	Cur.AddItem(IrvineItem);
}

uWindow.Imas_download=function(){
    var link = location.href;
    var title=Video.title;

	if(IMAS_flvp){
		var url=IMAS_flvp.GetVariable('o.url');
		if(url){
			if(url.match("low")){
				if(window.confirm('低画質モードですがDLしますか？')){ 
				}else{ 
					return;
				}
			}
		}
	}
	Imas_downloadWithIrvine( title , link );
	return;
}

//***********************************************
//　　　各種操作関数
//***********************************************
uWindow.Imas_copy2Wiki=function(){
	
	var title = document.getElementsByTagName("h1").item(0).childNodes(0).innerText;
    var link = location.href;
	var text  = "-[["+title+">"+link+"]]\r\n&nicovideo("+link+"){340,185}";
	
	clipboardData.setData("Text", text);
}

uWindow.Imas_ichiba=function(){
	var mainObj = document.getElementById("ichiba_edit_buttonB");
	if(!mainObj) return;
	var ht=mainObj.offsetTop-getWindowHeight()+10;
	if(ht>0)window.scroll(0,ht);
}

uWindow.Imas_toggleFooter=function(){
	var mainObj = document.getElementById("imas_footer_info");
	if(mainObj.style.display=="none"){
		mainObj.style.display='';
	}else{
		mainObj.style.display='none';
	}
}

uWindow.Imas_toggleBunner=function(){
	var mainObj = document.getElementById("flvplayer_container");
	if(mainObj.style.top=="-1px"){
		mainObj.style.top="-65px";
	}else{
		mainObj.style.top="-1px";
	}
}


//***********************************************
//　　　バックグランドタスク
//***********************************************
uWindow.Imas_setTimer =function(){
	if(!IMAS_isTimer){
		IMAS_isTimer=1;
		Imas_globalISR();
	}
}
function Imas_resetTimer(){
	if(IMAS_isTimer){
		IMAS_isTimer=0;
		clearTimeout(IMAS_handle_timer);
	}
}
function Imas_globalISR(){

	if(!IMAS_flvp){
		try{
			IMAS_flvp=uWindow.document.getElementById('flvplayer');
		}catch( e ){
		}
		IMAS_isTimer=500;
		if(IMAS_flvp){
			Imas_dispIcon();
		}
	}else if(IMAS_isState==0){
		IMAS_isTimer=IMAS_ratio_counter;
		var sai=IMAS_flvp.GetVariable('header.Members.text');
		if(IMAS_player_no!=sai){
			Imas_writeCounter(sai);
		}
	}
	else if(IMAS_isState==3){
		IMAS_isTimer=IMAS_ratio_readComment;
		var sai=IMAS_flvp.GetVariable('Messages.length');
		if(IMAS_message_no!=sai){
			Imas_readComments(sai);
		}
	}else{
		IMAS_isTimer=0;
		return;
	}
	IMAS_handle_timer=setTimeout(Imas_globalISR,IMAS_isTimer);
}

function Imas_dispIcon(){
	var icon_eco=IMAS_flvp.GetVariable('header.icon_narrow._visible');
	var icon_try=IMAS_flvp.GetVariable('header.icon_try._visible'   );
	if(icon_eco==null)return;
	var str="";
	str+=(icon_eco=='false')?"　":"エ";
	str+=(icon_try=='false')?"　":"試";
	document.getElementById("imas_player_icon").innerHTML=str;
}

function Imas_writeCounter(sai){
	if(!sai)return;
	IMAS_player_no=sai;
	var AryDst=document.getElementById("imas_player_numbers").getElementsByTagName("strong");
	AryDst[0].innerHTML=sai;
	AryDst[1].innerHTML=IMAS_flvp.GetVariable('header.Comments.text');
	AryDst[2].innerHTML=IMAS_flvp.GetVariable('header.MyLists.text');
}

function Imas_readComments(mes){
	var mainObj=document.getElementById("imas_readComment");
	var i = IMAS_message_no;
	var end= i+50;

	var flgAll=0;
	if(mainObj.childNodes[1].innerHTML=="コメ全部"){
		flgAll=1;
	}
	
	var strMarge='';
	while (mes > i && i<end) {
		var str=IMAS_flvp.GetVariable('Messages.'+i+'._message')+'<BR/>';
		if(str.match("sm[0-9]")){
			strMarge+=str.replace(/(sm[0-9]+)/g,'<A class=video href="http://www.nicovideo.jp/watch/$1">$1</A>');
		}else if(str.match("http://")){
			strMarge+=str.replace(/(http:\/\/[-_.!~*'()a-zA-Z0-9;/?:@&=+$,%#]+)/g,'<A class=video href="$1">$1</A>');
		}else if(flgAll){
			strMarge+=str;
		}
		i++;
	}

	mainObj.lastChild.innerHTML+=strMarge.replace(/\u000A/g,'"C-J"<BR/>'); 
	mainObj.firstChild.innerHTML=i+'/'+mes;
	IMAS_message_no=i;
}

//***********************************************
//　　　初期化関数
//***********************************************
function Imas_initComment(){
	var mainObj=document.getElementById("imas_readComment");
	var btnObj=mainObj.childNodes[1];
	if(btnObj.innerHTML=="コメ全部"){
		btnObj.innerHTML="リンクのみ";
	}else{
		btnObj.innerHTML="コメ全部";
	}
	mainObj.lastChild.innerHTML=""; 
	mainObj.firstChild.innerHTML="";
	IMAS_message_no=0;
	uWindow.Imas_setTimer();
}

function Imas_getThumbnail(headObj)
{
    //URLを変換
	document.getElementById("imas_download_button").innerHTML='<IMG class=cmn_thumb_img alt="'+Video.title+'" src="'+Video.thumbnail+'">';
	var AryDst=document.getElementById("imas_player_numbers").getElementsByTagName("strong");
	AryDst[0].innerHTML=Video.viewCount;
	AryDst[2].innerHTML=Video.mylistCount;
	return;
}

//***********************************************
//　　　FLV位置補正
//***********************************************
function Imas_resizePlayer(){
	if (uWindow.playerMaximized){

		var htmlObj = document.getElementsByTagName('html')[0];
		var bodyObj = document.getElementsByTagName('body')[0];
		var mainObj = document.getElementById("flvplayer_container");
		var selcObj = document.getElementById("imas_select_max_view");
		var iHeight=getWindowHeight()+eval(selcObj.options[selcObj.selectedIndex].value)-mainObj.style.pixelTop ;
		mainObj.style.pixelLeft=0;
		mainObj.style.height = iHeight;
		if(selcObj.selectedIndex==0){
			iHeight=getWindowHeight()+35 ;
		}else{
			iHeight=getWindowHeight() ;
			htmlObj.style.overflow = 'hidden';
			bodyObj.style.overflow = 'hidden';
		}
		htmlObj.style.height = iHeight;
		bodyObj.style.height = iHeight;
		uWindow.fitPlayerToWindow();
/**/
	}else{
		if(getWindowWidth()>960){
			document.getElementById("PAGEBODY").style.pixelLeft=(getWindowWidth()-960)/2;
		}else{
			document.getElementById("PAGEBODY").style.pixelLeft=0;
		}
		var minHeight=65;
		var disaObj=document.getElementById("imas_comment_provider");//IMAS_length_provider_comment_height
		var ht=getWindowHeight()-478-document.getElementById("WATCHHEADER").offsetHeight+disaObj.offsetHeight;
		if(ht<minHeight)ht=minHeight;
		if(ht<IMAS_length_provider_comment_height){
			disaObj.style.pixelHeight=ht;
		}else{
			disaObj.style.height="";
		}
	}
}

var toggleMaximizePlayer =function () {
	var pageObj = document.getElementById("PAGEBODY");
	playerMaximized = !playerMaximized;

	if (!playerMaximized) {
		uWindow.restorePlayer();
		document.getElementsByTagName('html')[0].style.overflow = "";
		document.getElementsByTagName('body')[0].style.overflow = "";
		pageObj.style.position="absolute";
	} else {
	//	maximizePlayer();
		$("PAGEHEADER", "WATCHHEADER", "WATCHFOOTER", "PAGEFOOTER").invoke("hide");
		var container = document.getElementById("flvplayer_container");
		["width", "height", "margin", "padding"].each(function (k) { containerStyle[k] = container.getStyle(k); });
		$$("html", "body", "#flvplayer_container").invoke("setStyle", { margin: "0", padding: "0", width: "100%", height: ""  });
		pageObj.style.position="";
	}
	Imas_resizePlayer();
}

function Imas_changeWatchPage(){
	var disaObj;
	var apndObj;

	//グローバルの初期化
	IMAS_tab_ctrl= new Object();
	IMAS_player_no=0;

	//各要素の取得
	var pghdObj = document.getElementById("PAGEHEADER");
	var headObj = document.getElementById("WATCHHEADER");
	var footObj = document.getElementById("WATCHFOOTER");
	var pgftObj = document.getElementById("PAGEFOOTER")
	var mainObj = document.getElementById("flvplayer_container");
	var pageObj = document.getElementById("PAGEBODY");

	//目的外ページなら抜ける
	if(headObj==null)return;//混雑中画面
	if(mainObj==null)return;//削除後のマイリスト画面
	if(pghdObj==null)return;//よく解んないけど一応
	if(pgftObj==null)return;//よく解んないけど一応
	if(pageObj==null)return;//よく解んないけど一応
	if(footObj==null)return;//よく解んないけど一応
	if(headObj.getElementsByTagName("TABLE")[1]==undefined)return;//マイリスト編集画面

	//必要なオブジェクトを取得する。
	var ichiObj = document.getElementById("ichiba_placeholder");
	var tagsObj = document.getElementById("video_controls");
	var selmObj = document.getElementById("mylist_add_group_id");
	var mmemObj = document.getElementById("mymemory_add_submit");

	//Tabの作成
	var tab1Obj = document.createElement("div");
	tab1Obj.id="WATCHHEADER";
	tab1Obj.innerHTML=''
	+'<DIV id="imas_main"></DIV>'
	+'<DIV id="imas_nicoichiba"></DIV>'
	+'<DIV id="imas_writeComment"></DIV>'
	+'<DIV id="imas_readComment" class="TXT12"><p></p><BUTTON onclick="Imas_initComment()"></BUTTON>'
				+'表示します<BR/><PRE></PRE></DIV>'
	+'<DIV id="imas_etc" class="TXT12"><BR/><BR/><BR/><a href="JavaScript:Imas_toggleFooter()">その他の要素を表示</a>'
				+'　　　<a href="JavaScript:Imas_toggleBunner()">ニワニュース表示</a></DIV>'
//	+'<iframe id="imas_xmlobj" style="display:none"></iframe>'
	;
	new IMAS_tabObj(tab1Obj,"imas_main_tab");
	
	//その他タブの作成
	disaObj=tab1Obj.childNodes[5];
	do{
		apndObj=headObj.lastChild;
		disaObj.appendChild(apndObj);
	}while(apndObj.tagName!="TABLE")
//?edit=owner comment 【コメント編集】  投稿者コメント作成

	//市場タブの作成
	if(ichiObj){
		tab1Obj.childNodes[2].appendChild(ichiObj.parentNode);
	}

	//Mainタブの作成
	Imas_addCSSRule("div.imas_tags"        ,"background: #eee;");
	disaObj = document.createElement("table");
	tab1Obj.childNodes[1].appendChild(disaObj);
	if(tagsObj){
		tagsObj.className="imas_tags";
		tab1Obj.childNodes[1].appendChild(tagsObj);
	}

	disaObj.style.width = '960px';
	disaObj.cellSpacing=0;
	disaObj.cellPadding=0;
	disaObj.border=0;
	apndObj = disaObj.insertRow(0).insertCell(0);
	apndObj.style.width = '100%';
	apndObj.style.padding="0px";
	
	var str=(Video.isMymemory)?
	('</STRONG> 保存 <STRONG style="COLOR: #f06">マイメモリー</STRONG> <A href="http://www.nicovideo.jp/watch/'+Video.id+'">&gt;&gt; 最新の状態</A> ')
	:('</STRONG> 投稿 ');
	apndObj.innerHTML=
		 '<DIV style="MARGIN: 4px 0px; valine: top"><P class=TXT12><STRONG>'
		+Video.postedAt.replace(/(\d+)\/(\d+)\/(\d+)/,'$1年$2月$3日')+str
		+'</P><H1><A class=video href="'
		+headObj.getElementsByTagName("h1")[0].getElementsByTagName("a")[0].href
		+'"target=_blank>'+Video.title
		+'</A></H1></DIV><P id=imas_comment_provider style="FONT-SIZE: 12px; OVERFLOW: auto; LINE-HEIGHT: 1.25">'+
		Video.description+'</P>';
	disaObj.rows[0].vAlign = 'top';

	var toolObj;
	var cellObj;
	//垂直ツールバーの作成
	Imas_addCSSRule("table.imas_vtool td"     ,"text-align: right;");
	toolObj=new IMAS_tableObj(6,3);
	disaObj.rows[0].insertCell(1).appendChild(toolObj.table);

	toolObj.table.id="imas_vertical_tool";
	toolObj.table.className="imas_vtool";
	toolObj.table.style.width = '326px';

	//検索バーの追加
	cellObj = toolObj.createCell(0,0,1,2);
	cellObj.innerHTML = '<FORM action=search method=get>'
		+'<INPUT type=hidden value=top name=ref><INPUT class=search name=s>'
		+'<INPUT class=submit style="MARGIN: 0px 8px" type=submit value=検索 name=submit></FORM>';

	//この動画のステータス表示の追加
	cellObj = toolObj.createCell(1,0,1,2);
	cellObj.id="imas_player_numbers";
	cellObj.style.padding="0px 8px";
	cellObj.className="TXT12";
	cellObj.innerHTML="再：<strong>0</strong> 米：<strong>0</strong> マ：<strong>0</strong><br/>";

	//マイリスト登録バーの追加
	cellObj = toolObj.createCell(2,0,1,2);
	if(selmObj){
		apndObj=selmObj.form;
		disaObj=apndObj.getElementsByTagName("table")[0];
		selmObj.style.margin="0px 8px";
		disaObj.parentNode.removeChild (disaObj);
		apndObj.appendChild(disaObj.getElementsByTagName("input")[0]);
		apndObj.appendChild(selmObj);
	}else{
		apndObj = document.createElement("div");
		apndObj.innerHTML="タブのMyPageからマイリストを作成しよう"
		apndObj.className="TXT10";
	}
	cellObj.appendChild(apndObj);

	//ステータス表示の追加
	cellObj = toolObj.createCell(3,0,1,3);
	cellObj.className="TXT12";
	cellObj.id="mylist_add_status";
	cellObj.innerHTML = '<strong id=imas_player_icon></strong><span style="white-space: nowrap;" title="'
	    +document.getElementById("dkb_bannertext").innerHTML +
	'">動:'+document.getElementById("dkb_video"  ).innerHTML
	+" 再:"+document.getElementById("dkb_view"   ).innerHTML
	+" ※:"+document.getElementById("dkb_comment").innerHTML+"</span>";

	//DLボタン追加
	cellObj = toolObj.createCell(0,2,3);
	cellObj.innerHTML = '<BUTTON id=imas_download_button onclick="Imas_download()" style="WIDTH: 100px; HEIGHT: 78px"></BUTTON>'

	//強制エコノミーモード
//	cellObj = toolObj.createCell(4,0);
//	cellObj.innerHTML='<DIV class=TXT14 style="WHITE-SPACE: nowrap"><A href="'
//					+location.href+'?eco=1">強制eco</A></DIV>';

	//マイメモリ登録ボタンの追加
	cellObj = toolObj.createCell(4,0,1,2);
	if(mmemObj){
//		mmemObj.innerHTML="米";
//		mmemObj.style.margin="0 8";
		cellObj.appendChild(mmemObj.form);
	}else{
		cellObj.innerHTML='<DIV class=TXT14 style="WHITE-SPACE: nowrap"><A href="'
						+location.href+'?edit=mymemory">マイメモリ編集</A></DIV>';
	}

	//最大化時の挙動を設定
	cellObj = toolObj.createCell(4,2);

	apndObj = document.createElement("Select");
	apndObj.id="imas_select_max_view";

	apndObj.options[0]=new Option("動画のみ", 95);
	apndObj.options[1]=new Option("Seek bar", 65);
	apndObj.options[2]=new Option("Comment" ,  5);
	apndObj.options[IMAS_selResizeMethod].selected=true;

	cellObj.appendChild(apndObj);

	//デバッグ用ボタン
	cellObj = toolObj.createCell(5,0,1,3);
	if(IMAS_debug){
	cellObj.innerHTML = '<BUTTON onclick="Imas_test()" style="WIDTH: 100px">テスト</BUTTON><BR/><DIV id=imas_test_text></DIV>';
	}

	toolObj.createTable();
	toolObj=null;
	cellObj=null;

	//レイアウト変更
	var hideObj = document.createElement("div");
		hideObj.id="imas_footer_info";
		hideObj.style.display='none';

	headObj.parentNode.removeChild (headObj);
	headObj.id="imas_org_header";
	hideObj.appendChild (pghdObj);
	hideObj.appendChild (headObj);
	hideObj.appendChild (footObj);
	hideObj.appendChild (pgftObj);

//	disaObj = hideObj.getElementsByTagName('img');
//	for(var i=0;i<disaObj.length;i++){ disaObj[i].src=""; }

	//ニワニュース消し
	mainObj.style.top="-65px";
	mainObj.style.position="absolute";
	pageObj.style.position="absolute";
	pageObj=null;
	mainObj=null;

	var dmy1Obj = document.createElement("div");
	dmy1Obj.innerHTML='<TABLE cellSpacing=0 cellPadding=0 border=0>'
	+'<TBODY><TR><TD style="HEIGHT: 475px"></TD></TR></TBODY></TABLE>';

	//レイアウト変更を反映
	disaObj = document.getElementsByTagName('body')[0];
	disaObj.style.backgroundImage='none';
	disaObj.appendChild(dmy1Obj);
	disaObj.appendChild(tab1Obj);
	disaObj.appendChild(hideObj);

	//遅延初期化
	IMAS_length_provider_comment_height=document.getElementById("imas_comment_provider").offsetHeight;
	Imas_getThumbnail(headObj);
	uWindow.restorePlayer();
	Imas_resizePlayer();
	Imas_initComment();
	uWindow.Imas_setTimer();
	//イベント追加
	addListener(window,"resize",Imas_resizePlayer);
	addListener(window,"focus",uWindow.Imas_setTimer);
	addListener(window,"blur",Imas_resetTimer);
}

function fnAddDownloadBtn(){
	var h=document.getElementsByTagName('h1')[0];
	var button = document.createElement("button");
	button.setAttribute("value","DL");
	button.attachEvent("onclick",Imas_download);
	h.appendChild(button);
}

//各ページに適応した変更を入れる
if(location.href.indexOf("/watch/",23)==23){
	/*
	コレにHitするパターン
	　本動画（スタイル適応）
	　マイメモリー再生（スタイル適応）
	　マイメモリー編集
	　削除されたマイメモリー再生
	　削除された本動画
	　削除された本動画ページ
	　混雑中の本動画、マイメモリ
	検証項目
	　スタイル適応の有無
	　適応時に"ニコ、下、DL、ニコ市場"の各ボタンの正常動作
	　拡大再生時の動作
	　ニコ市場編集時の動作
	　長い作者コメントでスクロールバーが出るか？
	*/

	if(IMAS_simple){
		addListener(window,"load",fnAddDownloadBtn,false);
	}else{
		addListener(window,"load",Imas_changeWatchPage,false);
	}
}else{
	var targObj=document.getElementById("web_pc_top");
	if(targObj){
		targObj.parentNode.removeChild (targObj);
	}
}

